<?php

namespace Mavabc\Communityoutreach;

use User;

class Communityoutreach
{
    /**
     * $community_outreach object.
     */
    protected $community_outreach;

    /**
     * Constructor.
     */
    public function __construct(\Mavabc\Communityoutreach\Interfaces\CommunityOutreachRepositoryInterface $community_outreach)
    {
        $this->community_outreach = $community_outreach;
    }

    /**
     * Returns count of communityoutreach.
     *
     * @param array $filter
     *
     * @return int
     */
    public function count()
    {
        return  0;
    }

    /**
     * Make gadget View
     *
     * @param string $view
     *
     * @param int $count
     *
     * @return View
     */
    public function gadget($view = 'admin.community_outreach.gadget', $count = 10)
    {

        if (User::hasRole('user')) {
            $this->community_outreach->pushCriteria(new \Litepie\Mavabc\Repositories\Criteria\CommunityOutreachUserCriteria());
        }

        $community_outreach = $this->community_outreach->scopeQuery(function ($query) use ($count) {
            return $query->orderBy('id', 'DESC')->take($count);
        })->all();

        return view('communityoutreach::' . $view, compact('community_outreach'))->render();
    }
}
